package handler

import (
	"fmt"
	"youngee_b_api/consts"
	"youngee_b_api/model/http_model"
	"youngee_b_api/service"
	"youngee_b_api/util"

	"github.com/gin-gonic/gin"
)

func WrapSendCodeHandler(ctx *gin.Context) {
	handler := newSendCodeHandler(ctx)
	baseRun(handler)
}

func newSendCodeHandler(ctx *gin.Context) *SendCodeHandler {
	return &SendCodeHandler{
		req:  http_model.NewSendCodeRequest(),
		resp: http_model.NewSendCodeResponse(),
		ctx:  ctx,
	}
}

type SendCodeHandler struct {
	req  *http_model.SendCodeRequest
	resp *http_model.CommonResponse
	ctx  *gin.Context
}

func (h *SendCodeHandler) getRequest() interface{} {
	return h.req
}
func (h *SendCodeHandler) getContext() *gin.Context {
	return h.ctx
}
func (h *SendCodeHandler) getResponse() interface{} {
	return h.resp
}
func (h *SendCodeHandler) run() {

	data := http_model.SendCodeRequest{}
	data = *h.req
	fmt.Println(data.UserPhone)
	// 1. 生成验证码
	vcode := service.SendCode.GetCode(h.ctx)
	// 2. 发送验证码
	fmt.Println(vcode)

	// 3. {phone:code}存到redis
	err := service.SendCode.SetSession(h.ctx, data.UserPhone, vcode)
	if err != nil {
		util.HandlerPackErrorResp(h.resp, consts.ErrorInternal)
		return
	}
	res := http_model.SendCodeData{
		UserPhone: data.UserPhone,
	}
	h.resp.Data = res
}
func (h *SendCodeHandler) checkParam() error {
	return nil
}
