package service

import (
	"context"
	"fmt"
	"time"
	"youngee_b_api/consts"
	"youngee_b_api/db"
	"youngee_b_api/redis"
)

var Register *register

type register struct {
	sessionTTL time.Duration
}

func (r *register) Register(ctx context.Context, phone string, vcode string) (*int64, error) {
	user, err := db.GetUserByPhone(ctx, phone)
	if err != nil {
		return nil, err
	} else if user != nil {
		return &user.ID, nil
	} else {
		code, err := r.getSession(ctx, phone)
		if err != nil {
			return nil, err
		} else {
			fmt.Printf("%+v", code)
			if *code != vcode {
				return &user.ID, nil
			} else {
				return nil, nil
			}
		}
	}
}

func (r *register) getSession(ctx context.Context, phone string) (*string, error) {
	value, err := redis.Get(ctx, r.getRedisKey(phone))
	if err != nil {
		if err == consts.RedisNil {
			return nil, fmt.Errorf("not found in redis,phone:%+v", phone)
		}
		return nil, err
	}
	return &value, nil
}

func (r *register) getRedisKey(key string) string {
	return fmt.Sprintf("%s%s", consts.SessionRedisPrefix, key)
}
